Subject: [manet] RE: DPD for IPv6 - fragmentation support

From: "Joe Macker" <[email-masked]>
Date: Thu, 2 Aug 2007 15:51:30 -0400

Hi Teco:

Yes, IPv6 source fragmentation packets will be supported at least that is
the plan for now. Yes the identification field is helpful in that case and
can be used.

Re. hashing, yes we are adding hashing for IPv4 as well as an option.
Mutable fields need to be skipped as you point out.

Document changes planned in -06:

- Revise IPv4 SMF DPD, expand tuple processing, no ID field modification,
support fragmentation, support optional hashing as per IPv6
- Revise IPv6 SMF DPD to support IPv6 source-based fragmentation (no header
option should be needed)
- Editorial changes throughout (Templin's comments/others)
- Provide clearer discussion of implementation requirements for
interoperability.

>-----Original Message-----
>From: Teco_Boot [mailto:[email-masked]] 
>Sent: Tuesday, July 31, 2007 4:01 AM
>To: 'Joe Macker'
>Cc: [email-masked]
>Subject: DPD for IPv6 - fragmentation support
>
>Hi Joe,
>
> 
>
>As fragmentation with IPv4 is to be supported, IPv6 
>fragmentation support can be considered too.
>
>It even brings efficiency, as adding the DPD header is 
>eliminated if a fragment header was included by the source.
>
>Draft algorithm below. I am not sure about the optional 
>tagging *), this depends on the --to be written-- rules for 
>used SMF mechanisms in a MANET.
>
> 
>
>I am not a protocol implementer. But if, I would consider a 
>single hash table for IPv4 and IPv6 and run the hash algorithm 
>over those fields that guarantee uniqueness, or over the first 
>N octets of a frame with blanked fields TTL, TOS and 
>hop-by-hop & routing headers. Code maintaining the table and 
>performing fast lookups would be shared for all types of traffic.
>
> 
>
>Teco.
>
> 
>
> 
>
>+-------------+-----------------+-------------+----------------
>--------------------------+
>
>|IPsec header | Fragment header | DPD header  | action         
>                          |
>
>+-------------+-----------------+-------------+----------------
>--------------------------+
>
>| present     |       *         |      *      | IPsec header 
>DPD check and forward       |       
>
>| not present | present         | not present | Fragment 
>header DPD check and forward (1)|
>
>| not present | present         | present     | invalid, do 
>not forward (2)              |
>
>| not present | not present     | not present | Optionally tag 
>and forward (3)           |
>
>| not present | not present     | present     | DPD header DPD 
>check and forward         |
>
>+-------------+-----------------+-------------+----------------
>--------------------------+
>
> 
>
>1: DPD check based on 
><sourceAddress::destinationAddress::Identification::FragmentOffset>
>
> 
>
>2: SMF shall use fragment header if present. Adding DPD header 
>should never occur.
>
> 
>
>3: Received packets are sent by connected hosts or forwarded 
>by MANET SMF routers implementing DPD based on hashing. 
>Tagging is optional *).
>
> 
>
> 
>
> 
>
>

_______________________________________________
manet mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/manet

---

From: "Edward J. Paradise" <[email-masked]>
Date: Wed, 8 Aug 2007 15:56:16 -0400

Do you think it would be possible in the 06 draft to include a flow  
chart in appendix A, "Source-based Multipoint Relay (S-MPR)", that  
describes the forwarding algorithm for implementations using S-MPR?   
I found it hard to follow when a packet should be marked and what  
decisions should be made based on those markings with respect to  
multiple interfaces.  Also, you referenced border gateway experiments  
with PIM in the draft and during your IETF presentation.  Do you have  
any examples you could share?  -ed

---

From: "Joe Macker" <[email-masked]>
Date: Wed, 8 Aug 2007 17:07:49 -0400

Ed:

The PIM gateway we have running simple proxy approach at the gateway
Ethernet interface in our experiment.  SMF supports forwarding between the
interfaces (MANET wireless on one side and Ethernet in this case).  This was
a simple stub network configuration and was used in our wireless-based
emulator.  We did some international IPv6 lab-to-lab with this at one point.
I might delete this from the ID, but it does provide a basic example of
interfacing SMF to a backbone PIM-cloud.  

There are multiple considerations and methods to accomplish this obviously
and is ongoing work.

S-MPR question obviously the previous-hop dependency is an issue and is
pointed out. OLSRv2 spec discusses multiple interface S-MPR issues and we
reference it. I hope that's a start.  It's a good comment and has some
implementation specific issues that may be done multiple ways but the
expected behavior for interoperability should be understood.

-Joe

>From: Edward J. Paradise [mailto:[email-masked]] 
>Sent: Wednesday, August 08, 2007 3:56 PM
>To: Joe Macker
>Cc: 'Teco_Boot'; [email-masked]
>Subject: Re: [manet] RE: DPD for IPv6 - fragmentation support
>
>Do you think it would be possible in the 06 draft to include a 
>flow chart in appendix A, "Source-based Multipoint Relay 
>(S-MPR)", that  
>I found it hard to follow when a packet should be marked and 
>what decisions should be made based on those markings with 
>respect to multiple interfaces.  Also, you referenced border 
>gateway experiments with PIM in the draft and during your IETF 
>presentation.  Do you have any examples you could share?  -ed
>
>> Yes, IPv6 source fragmentation packets will be supported at 
>least that 
>> is the plan for now. Yes the identification field is helpful in that 
>> case and can be used.
>>
>> - Revise IPv4 SMF DPD, expand tuple processing, no ID field 
>> modification, support fragmentation, support optional hashing as per 
>> IPv6
>> - Revise IPv6 SMF DPD to support IPv6 source-based fragmentation (no 
>> header option should be needed)